{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            FaultInterventionType:{routeName:'FaultInterventionType-getComboValues',table:'fault_intervention_types',modulename:'FaultInterventionType',fieldId:'code',fieldDisplay:"concat(code,'-',description)"}
            ,FaultInterventionTypeG:{routeName:'FaultInterventionType-getComboValues',table:'fault_intervention_types',modulename:'FaultInterventionType',fieldId:'code',fieldDisplay:"concat(code,'-',description)"}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.stores.answertypes=new mj.store({
                data:[{id:'yesno',code:"{{ 'FaultIntervention.answertype_yesno'|trans }}"}
                    ,{id:'oknok',code:"{{ 'FaultIntervention.answertype_oknok'|trans }}"}
                    ,{id:'uygun',code:"{{ 'FaultIntervention.answertype_uygun'|trans }}"}
                    ,{id:'number',code:"{{ 'FaultIntervention.answertype_number'|trans }}"}
                    ,{id:'text',code:"{{ 'FaultIntervention.answertype_text'|trans }}"}
                ]
            });
            t.checks = {};
	        t.stationData = {};
            const gridConfig = {
                cm: [
                    {header: "{{ 'FaultIntervention.faultinterventiontype'|trans }}", dataIndex: 'faultinterventiontype', width: 150,filter:'single',type:'combo',store:t.stores.FaultInterventionTypeG,alias:'fi',operator:'='},
                    {header: "{{ 'FaultIntervention.name'|trans }}", dataIndex: 'name', width: 250,filter:'between',alias:'fi'},
                    {header: "{{ 'FaultIntervention.controlname'|trans }}", dataIndex: 'controlname', width: 250,filter:'between',alias:'fi'},
                    {header: "{{ 'FaultIntervention.start'|trans }}", dataIndex: 'start', width: 100,filter:'between', type:'date',alias:'fi'},
                    {header: "{{ 'FaultIntervention.finish'|trans }}", dataIndex: 'finish', width: 100,filter:'between', type:'date',alias:'fi'}
                ]
            };

            t._setGridConfig(gridConfig);
            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : "{{ 'FaultIntervention.clients'|trans }}",
                        labelWidth : '110px',
                        width : 200,
                        height : 510
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 600,
                        height : 510,
                        style : 'position:absolute;top:0px;left:240px;',
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.combo({
                                title: "{{ 'FaultIntervention.faultinterventiontype'|trans }}",
                                placeHolder: "{{ 'FaultIntervention.faultinterventiontype'|trans }}",
                                dataIndex: 'faultinterventiontype',
                                labelWidth : '120px',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                notEmpty: true,
                                grid: 's12 m6',
                                width: 400,
                                store: t.stores.FaultInterventionType
                            }),
                            new mj.form.textField({
                                title: "{{ 'FaultIntervention.name'|trans }}",
                                dataIndex: 'name',
                                maxLength: 255,
                                labelWidth : '120px',
                                width:400,
                                grid: 's4 m2'
                            }),
                            new mj.form.fieldSet({
                                id : 'f3',
                                title : "{{ 'FaultIntervention.interventions'|trans }}",
                                labelWidth : '110px',
                                width : 560,
                                height : 100,
                                items:[
                                    new mj.form.checkBox({
                                        title : 'BAKIM PERSONELİ',
                                        id : 'interventions_ismaintenance',
                                        labelWidth : '170px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions'/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'FİKSTÜR BAKIMCI',
                                        id : 'interventions_fikstur',
                                        labelWidth : '170px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'FORMEN',
                                        id : 'interventions_formen',
                                        labelWidth : '90px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'KALIP BAKIM',
                                        id : 'interventions_ismould',
                                        labelWidth : '170px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions'/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'TİM LİDERİ',
                                        id : 'interventions_timlider',
                                        labelWidth : '170px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'TEKNİKER',
                                        id : 'interventions_tekniker',
                                        labelWidth : '90px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'ÜRETİM BAKIM',
                                        id : 'interventions_isexpert',
                                        labelWidth : '170px',
                                        labelPos : 'right',
                                        dataIndex : 'interventions'/*,
                                        checked : st.data[i].checked*/
                                    })
                                ]
                            }),
                            new mj.form.textField({
                                title: "{{ 'FaultIntervention.controlname'|trans }}",
                                dataIndex: 'controlname',
                                maxLength: 255,
                                labelWidth : '120px',
                                width:400,
                                grid: 's4 m2'
                            }),
                            new mj.form.fieldSet({
                                id : 'f4',
                                title : "{{ 'FaultIntervention.controlofficers'|trans }}",
                                labelWidth : '110px',
                                width : 560,
                                height : 50,
                                items:[
                                    new mj.form.checkBox({
                                        title : 'BAKIM',
                                        id : 'controlofficers_ismaintenance',
                                        labelWidth : '70px',
                                        labelPos : 'right',
                                        dataIndex : 'controlofficers'/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'KALIP BAKIM',
                                        id : 'controlofficers_ismould',
                                        labelWidth : '110px',
                                        labelPos : 'right',
                                        dataIndex : 'controlofficers',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    }),
                                    new mj.form.checkBox({
                                        title : 'ÜRETİM',
                                        id : 'controlofficers_isexpert',
                                        labelWidth : '70px',
                                        labelPos : 'right',
                                        dataIndex : 'controlofficers',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    })
                                    ,new mj.form.checkBox({
                                        title : 'KALİTE',
                                        id : 'controlofficers_isquality',
                                        labelWidth : '70px',
                                        labelPos : 'right',
                                        dataIndex : 'controlofficers',
                                        right:true/*,
                                        checked : st.data[i].checked*/
                                    })
                                ]
                            }),
                            new mj.form.combo({
                                title: "{{ 'FaultIntervention.answertype'|trans }}",
                                placeHolder: "{{ 'FaultIntervention.answertype_placeholder'|trans }}",
                                dataIndex: 'answertype',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                sameValueDisplay:true,
                                labelWidth : '120px',
                                grid: 's6 m4',
                                store: t.stores.answertypes
                            }),
                            new mj.form.checkBox({
                                title : "{{ 'FaultIntervention.isallowna'|trans }}",
                                id : 'isallowna',
                                labelWidth : '220px',
                                labelPos : 'right',
                                dataIndex : 'isallowna',
                                right:true
                            }),
                            new mj.form.textField({
                                title: "{{ 'FaultIntervention.valuerequire'|trans }}",
                                dataIndex: 'valuerequire',
                                maxLength: 100,
                                labelWidth : '120px',
                                grid: 's4 m2'
                            }),
                            new mj.form.textField({
                                title: "{{ 'FaultIntervention.valuemin'|trans }}",
                                dataIndex: 'valuemin',
                                maxLength: 100,
                                labelWidth : '120px',
                                grid: 's4 m2'
                            }),
                            new mj.form.textField({
                                title: "{{ 'FaultIntervention.valuemax'|trans }}",
                                dataIndex: 'valuemax',
                                maxLength: 100,
                                labelWidth : '120px',
                                grid: 's4 m2'
                            }),
                            new mj.form.dateField({
                                title: "{{ 'FaultIntervention.start'|trans }}",
                                dataIndex: 'start',
                                labelWidth : '120px',
                                width : 80,
                                notEmpty: true,
                                grid: 's4 m2'
                            }),
                            new mj.form.dateField({
                                title: "{{ 'FaultIntervention.finish'|trans }}",
                                dataIndex: 'finish',
                                labelWidth : '120px',
                                width : 80,
                                grid: 's4 m2'
                            }),
                            new mj.form.textArea({
                                title : "{{ 'FaultIntervention.mailto'|trans }}",
                                dataIndex : 'mailto',
                                labelWidth : '120px',
                                width:400,
                                height:50,
                                maxLength: 1000
                            })
                        ]
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.buttons.selectNone = t.forms.main.addButton({
                alt: "{{ 'FaultIntervention.selectNone'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox',
                scope: t,
                handler: function(){
                    t.checker(0);
                }
            });
            t.buttons.selectAll = t.forms.main.addButton({
                alt: "{{ 'FaultIntervention.selectAll'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox-checked',
                scope: t,
                handler: function(){
                    t.checker(1);
                }
            });

            t.len=t.forms.main.items.length;
            
            for(var i = 0,l = t.extras.clients.length;i<l;i++){
                if(t.forms.main.items.getIndex('id','client_' + t.extras.clients[i].code) === -1){
                    t.forms.main.add(
                        new mj.form.checkBox({
                            title : t.extras.clients[i].code,
                            id : 'client_' + t.extras.clients[i].code,
                            labelWidth : '150px',
                            labelPos : 'right',
                            dataIndex : 'client'/*,
                            checked : st.data[i].checked*/
                        }),'f1'
                    );
                }
            }
            t.checks.client = t.forms.main.items[0].items;
            //t.tabPanels.main.setActive(0);
        },
        checker : function(v){
            var t=this;
            var bi = t.forms.main.items[0].items;
            for(var i=0;i<bi.length;i++){
                bi[i].setValue(v);
            }
        },
        editSelectedRecord: function(){
            var t=this;
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false){
                t.editData(selectedRecord);
                var s = selectedRecord.clients.split("|");
                i=-1;
                var f;
                while(++i<s.length){
                    f = 'client_'+s[i];
                    var fi = t.forms.main.getField(f);
                    if(fi){
                        fi.setValue(1);
                    }
                }
                var interventions = selectedRecord.interventions.split("|");
                i=-1;
                var f;
                while(++i<interventions.length){
                    f = 'interventions_'+interventions[i];
                    var fi = t.forms.main.getField(f);
                    if(fi){
                        fi.setValue(1);
                    }
                }
                var controlofficers = selectedRecord.controlofficers.split("|");
                i=-1;
                var f;
                while(++i<controlofficers.length){
                    f = 'controlofficers_'+controlofficers[i];
                    var fi = t.forms.main.getField(f);
                    if(fi){
                        fi.setValue(1);
                    }
                }
            }
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var data = f.getValue();
                    if(data.faultinterventiontype===''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'FaultIntervention.errFaultinterventiontypeNotSelected'|trans }}");
                    }else{
                        var clients="";
                        var flag=false;
                        for(var i = 0 , l = t.checks.client.length;i<l;i++){
                            if(t.checks.client[i].checked){
                                flag=true;
                                id = t.checks.client[i].id.replace('client_','');
                                clients=(clients==""?id:clients+"|"+id);
                            }
                        }
                        if(!flag){
                            //t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                            t.messageShow(t,mj.lng.glb.error,"{{ 'FaultIntervention.errClientNotSelected'|trans }}");
                        }else{
                            var interventions="";
                            var flag_interventions=false;
                            var idx_interventions=t.forms.main.items.getIndex('id','f3');
                            if(idx_interventions!==-1){
                                for(var i = 0 , l = t.forms.main.items[idx_interventions].items.length;i<l;i++){
                                    if(t.forms.main.items[idx_interventions].items[i].checked){
                                        flag_interventions=true;
                                        id = t.forms.main.items[idx_interventions].items[i].id.replace('interventions_','');
                                        interventions=(interventions==""?id:interventions+"|"+id);
                                    }
                                }
                            }
                            if(!flag_interventions){
                                t.messageShow(t,mj.lng.glb.error,"{{ 'FaultIntervention.errInterventionsNotSelected'|trans }}");
                            }else{
                                //console.log(interventions);
                                var controlofficers="";
                                var flag_controlofficers=false;
                                var idx_controlofficers=t.forms.main.items.getIndex('id','f4');
                                if(idx_controlofficers!==-1){
                                    for(var i = 0 , l = t.forms.main.items[idx_controlofficers].items.length;i<l;i++){
                                        if(t.forms.main.items[idx_controlofficers].items[i].checked){
                                            flag_controlofficers=true;
                                            id = t.forms.main.items[idx_controlofficers].items[i].id.replace('controlofficers_','');
                                            controlofficers=(controlofficers==""?id:controlofficers+"|"+id);
                                        }
                                    }
                                    if(!flag_controlofficers){
                                        t.messageShow(t,mj.lng.glb.error,"{{ 'FaultIntervention.errControlofficersNotSelected'|trans }}");
                                    }else{
                                        //console.log(controlofficers);
                                        
                                        data.clients=clients;
                                        data.interventions=interventions;
                                        data.controlofficers=controlofficers;
                                        
                                        delete data.client;
                                        t.waitMaskShow();
                                        var id = f.getValue('id').id;
                                        var versionField = f.getField('version');
                                        var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                                        var mode = id ? 'update' : 'add';
                                        var routeName = f.modulename + '-' + mode;
                                        var route = Routing.getRoute(routeName);
                                        var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                                            'pg': t.grids.main.pbar.current,
                                            'lm': t.grids.main.pbar.limit
                                        } : {'pg':1,'lm':25};
                                        var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                                            'id': id,
                                            'v': version
                                        }) : pagerParams);
                                        
                                        data.menuId = t.id;
                                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                                            t.waitMaskShow();
                                            t._event='save';
                                            $.ajax({
                                                url: url,
                                                method: "POST",
                                                headers: { 
                                                    "Content-Type": "application/json",
                                                    "X-HTTP-Method-Override": route.methods[0] 
                                                },
                                                data: JSON.stringify(data),
                                                dataType: 'json',
                                                success: function(data, textStatus, xhr) {
                                                    t.reset(_f, data);
                                                },
                                                error: function(xhr, textStatus, errorThrown) {
                                                    t.waitMaskHide();
                                                    if(xhr.responseJSON&&xhr.responseJSON.message){
                                                        mj.message({
                                                            title: mj.lng.glb.error,
                                                            msg: xhr.responseJSON.message,
                                                            type: "error",
                                                            html: true
                                                        });
                                                    }
                                                },
                                                complete: function(jqXHR, textStatus) {
                                                    //t.waitMaskHide();
                                                }
                                            });
                                        }
                                    }
                                }
                            }
                        }
                    }
                    
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
